
#include <Wire.h>
#include "Gesture.h"
#define GES_ENTRY_TIME			800				// When you want to recognize the Forward/Backward gestures, your gestures' reaction time must less than GES_ENTRY_TIME(0.8s). 
#define GES_QUIT_TIME			1000

#define ON 1     //enable LED
#define OFF 0    //disable LED

int LED_R = 10;  //LED_R connect pin 10 of Arduino
int LED_G = 11;  //LED_G connect pin 11 of Arduino
int LED_B = 9;   //LED_B connect pin 9 of Arduino

/*
* Function       color_led
* @author        Jessica
* @date          2019.8.21  
* @brief         7 different colors are formed by different combinations of R, G and B
* @param[in1]    Red
* @param[in2]    Green
* @param[in3]    Blue
* @retval        void
* @par History   no
*/
void color_led(int v_iRed, int v_iGreen, int v_iBlue)
{
   //Red LED
  if (v_iRed == ON)
  {
      digitalWrite(LED_R, HIGH);//light up
  }
  else
  {
      digitalWrite(LED_R, LOW);//light off
  }
  //Green LED
  if (v_iGreen == ON)
  {
      digitalWrite(LED_G, HIGH);//light up
  }
  else
  {
      digitalWrite(LED_G, LOW);//light off
  }
  //Blue LED
  if (v_iBlue == ON)
  {
      digitalWrite(LED_B, HIGH);//light up
  }
  else
  {
      digitalWrite(LED_B, LOW);//light off
  }
}

void setup()
{
	uint8_t error = 0;
  pinMode(LED_R, OUTPUT);
  pinMode(LED_G, OUTPUT);
  pinMode(LED_B, OUTPUT);
	Serial.begin(9600);
	Serial.println("\nGesture TEST DEMO: Recognize 9 gestures.");
	error = GestureInit();			// initialize Paj7620 registers
	if (error){
		Serial.print("INIT ERROR,CODE:");
		Serial.println(error);
	}
	else{
		Serial.println("INIT OK");
	}
	Serial.println("Please input your gestures:\n");
}

void loop()
{
	uint8_t data = 0, data1 = 0, error;
	error = GestureReadReg(0x43, 1, &data);				// Read Bank_0_Reg_0x43/0x44 for gesture result.
	if (!error){
		switch (data){
			case GES_RIGHT_FLAG:
				delay(200);
				GestureReadReg(0x43, 1, &data);
				if(data == GES_FORWARD_FLAG){
          color_led(ON, OFF, ON);
					Serial.println("Forward");
					delay(GES_QUIT_TIME);
				}
				else if(data == GES_BACKWARD_FLAG){
          color_led(OFF, ON, ON); 
					Serial.println("Backward");
					delay(GES_QUIT_TIME);
				}
				else{
          color_led(ON, OFF, OFF);
					Serial.println("Right");
				}          
				break;
        
			case GES_LEFT_FLAG: 
				delay(200);
				GestureReadReg(0x43, 1, &data);
				if(data == GES_FORWARD_FLAG){
          color_led(ON, OFF, ON);
					Serial.println("Forward");
					delay(GES_QUIT_TIME);
				}
				else if(data == GES_BACKWARD_FLAG){
              color_led(OFF, ON, ON); 
					Serial.println("Backward");
					delay(GES_QUIT_TIME);
				}
				else{
          color_led(OFF, ON, OFF);
					Serial.println("Left");
				}          
				break;
        
			case GES_UP_FLAG:
				delay(200);
				GestureReadReg(0x43, 1, &data);
				if(data == GES_FORWARD_FLAG){
          color_led(ON, OFF, ON);
					Serial.println("Forward");
					delay(GES_QUIT_TIME);
				}
				else if(data == GES_BACKWARD_FLAG){
          color_led(OFF, ON, ON); 
					Serial.println("Backward");
					delay(GES_QUIT_TIME);
				}
				else{
          color_led(OFF, OFF, ON);
					Serial.println("Up");
				}          
				break;
        
			case GES_DOWN_FLAG:
				delay(200);
				GestureReadReg(0x43, 1, &data);
				if(data == GES_FORWARD_FLAG){
          color_led(ON, OFF, ON);
					Serial.println("Forward");
					delay(GES_QUIT_TIME);
				}
				else if(data == GES_BACKWARD_FLAG){
          color_led(OFF, ON, ON);
					Serial.println("Backward");
					delay(GES_QUIT_TIME);
				}
				else{
          color_led(ON, ON, OFF);
					Serial.println("Down");
				}          
				break;
        
			case GES_FORWARD_FLAG:
        color_led(ON, OFF, ON);
				Serial.println("Forward");
				delay(GES_QUIT_TIME);
				break;
        
			case GES_BACKWARD_FLAG:	
        color_led(OFF, ON, ON);	  
				Serial.println("Backward");
				delay(GES_QUIT_TIME);
				break;
        
			case GES_CLOCKWISE_FLAG:
				Serial.println("Clockwise");
				break;
        
			case GES_COUNT_CLOCKWISE_FLAG:
				Serial.println("anti-clockwise");
				break;
          
			default:
				GestureReadReg(0x44, 1, &data1);
				if (data1 == GES_WAVE_FLAG){
          color_led(OFF, OFF, OFF);
          delay(GES_QUIT_TIME);
					Serial.println("wave");
				}
				break;
		}
	}
	delay(100);
}
